import { IMidwayContainer } from '@midwayjs/core';
import { ApiFunction, ApiModule } from '../types/common';
import { ServerRouter } from '../router';
import { RuntimeConfig, InternalConfig } from '../types/config';
import { ApiHttpMethod } from '../types/http';
export declare type ComponentConfig = {
    runtime: RuntimeConfig;
    internal: InternalConfig;
    router: ServerRouter;
    root: string;
};
export declare class HooksDevComponent {
    internal: InternalConfig;
    runtime: RuntimeConfig;
    router: ServerRouter;
    root: string;
    container: IMidwayContainer;
    constructor(config: ComponentConfig);
    init(): {
        Configuration: import("@midwayjs/core/dist/functional/configuration").FunctionalConfiguration;
    };
    afterCreate(): void;
    createApi(mod: ApiModule, file: string): void;
    createApiFunction(config: {
        fn: ApiFunction;
        file: string;
        isExportDefault: boolean;
        modMiddleware: any[];
    }): void;
    getFunctionId(file: string, functionName: string, isExportDefault: boolean): string;
    registerApiFunction(config: {
        containerId: string;
        httpMethod: ApiHttpMethod;
        httpPath: string;
        fn: ApiFunction;
    }): void;
    useGlobalMiddleware(app: any): void;
    useAsyncLocalStorage: (ctx: any, next: any) => Promise<void>;
    useHooksMiddleware(fn: Function): (...args: any[]) => any;
    isFullStackProject(): boolean;
}
