'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var axios = require('axios');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () {
            return e[k];
          }
        });
      }
    });
  }
  n['default'] = e;
  return Object.freeze(n);
}

var axios__default = /*#__PURE__*/_interopDefault(axios);

const defaults = {
  async request(param) {
    const enableSuperjson = param.meta && param.meta.superjson;

    try {
      const response = await axios__default['default']({
        baseURL: defaults.baseURL,
        ...param
      });

      if (response) {
        const superjson = await Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require('superjson')); });
        return enableSuperjson ? superjson.deserialize(response.data) : response.data;
      }

      return response;
    } catch (error) {
      if (enableSuperjson) {
        const e = error;
        throw e.response.data;
      }

      throw error;
    }
  },

  baseURL: ''
};
function request(param) {
  return defaults.request(param);
}

exports.defaults = defaults;
exports.request = request;
