import axios from 'axios';

const defaults = {
  async request(param) {
    const enableSuperjson = param.meta && param.meta.superjson;

    try {
      const response = await axios({
        baseURL: defaults.baseURL,
        ...param
      });

      if (response) {
        const superjson = await import('superjson');
        return enableSuperjson ? superjson.deserialize(response.data) : response.data;
      }

      return response;
    } catch (error) {
      if (enableSuperjson) {
        const e = error;
        throw e.response.data;
      }

      throw error;
    }
  },

  baseURL: ''
};
function request(param) {
  return defaults.request(param);
}

export { defaults, request };
